Index: apps/app_chanspy.c
===================================================================
--- apps/app_chanspy.c	(revision 189812)
+++ apps/app_chanspy.c	(working copy)
@@ -95,6 +95,9 @@
 						either a single group or a colon-delimited list of groups, such
 						as <literal>sales:support:accounting</literal>.</para></note>
 					</option>
+					<option name="h">
+						<para>Hang up when the spied-on channel hangs up.</para>
+					</option>
 					<option name="n" argsep="@">
 						<para>Say the name of the person being spied on if that person has recorded
 						his/her name. If a context is specified, then that voicemail context will
@@ -216,6 +219,10 @@
 						either a single group or a colon-delimited list of groups, such
 						as <literal>sales:support:accounting</literal>.</para></note>
 					</option>
+					<option name="h">
+						<para>Hang up when the spied-on channel hangs up.</para>
+					</option>
+
 					<option name="n" argsep="@">
 						<para>Say the name of the person being spied on if that person has recorded
 						his/her name. If a context is specified, then that voicemail context will
@@ -308,6 +315,8 @@
 	OPTION_BARGE             = (1 << 11),   /* Barge mode (whisper to both channels) */
 	OPTION_NAME              = (1 << 12),   /* Say the name of the person on whom we will spy */
 	OPTION_DTMF_SWITCH_MODES = (1 << 13),   /*Allow numeric DTMF to switch between chanspy modes */
+	OPTION_HANGUP		 = (1 << 14),	/* Hang up when the spied-on channel hangs up. */
+
 } chanspy_opt_flags;
 
 enum {
@@ -320,20 +329,21 @@
 } chanspy_opt_args;
 
 AST_APP_OPTIONS(spy_opts, {
-	AST_APP_OPTION('q', OPTION_QUIET),
 	AST_APP_OPTION('b', OPTION_BRIDGED),
 	AST_APP_OPTION('B', OPTION_BARGE),
+	AST_APP_OPTION('d', OPTION_DTMF_SWITCH_MODES),
+	AST_APP_OPTION_ARG('e', OPTION_ENFORCED, OPT_ARG_ENFORCED),
+	AST_APP_OPTION_ARG('g', OPTION_GROUP, OPT_ARG_GROUP),
+	AST_APP_OPTION('h', OPTION_HANGUP),
+	AST_APP_OPTION_ARG('n', OPTION_NAME, OPT_ARG_NAME),
+	AST_APP_OPTION('o', OPTION_READONLY),
+	AST_APP_OPTION('q', OPTION_QUIET),
+	AST_APP_OPTION_ARG('r', OPTION_RECORD, OPT_ARG_RECORD),
+	AST_APP_OPTION('s', OPTION_NOTECH),
+	AST_APP_OPTION_ARG('v', OPTION_VOLUME, OPT_ARG_VOLUME),
 	AST_APP_OPTION('w', OPTION_WHISPER),
 	AST_APP_OPTION('W', OPTION_PRIVATE),
-	AST_APP_OPTION_ARG('v', OPTION_VOLUME, OPT_ARG_VOLUME),
-	AST_APP_OPTION_ARG('g', OPTION_GROUP, OPT_ARG_GROUP),
-	AST_APP_OPTION_ARG('r', OPTION_RECORD, OPT_ARG_RECORD),
-	AST_APP_OPTION_ARG('e', OPTION_ENFORCED, OPT_ARG_ENFORCED),
-	AST_APP_OPTION('o', OPTION_READONLY),
 	AST_APP_OPTION('X', OPTION_EXIT),
-	AST_APP_OPTION('s', OPTION_NOTECH),
-	AST_APP_OPTION_ARG('n', OPTION_NAME, OPT_ARG_NAME),
-	AST_APP_OPTION('d', OPTION_DTMF_SWITCH_MODES),
 });
 
 static int next_unique_id_to_use = 0;
@@ -764,6 +774,7 @@
 	char *ptr;
 	int num;
 	int num_spyed_upon = 1;
+	int hungup = 0;
 	struct chanspy_ds chanspy_ds = { 0, };
 
 	if (ast_test_flag(flags, OPTION_EXIT)) {
@@ -1000,8 +1011,16 @@
 				}
 
 				peer = NULL;
+			} else if ( res == 0 && ast_test_flag(flags, OPTION_HANGUP)) {
+				hungup=1; //to break the outter loop
+				break;
 			}
 		}
+
+		if (hungup) {
+			break;
+		}
+
 		if (res == -1 || ast_check_hangup(chan))
 			break;
 	}
@@ -1015,6 +1034,12 @@
 	ast_mutex_unlock(&chanspy_ds.lock);
 	ast_mutex_destroy(&chanspy_ds.lock);
 
+	if (ast_test_flag(flags, OPTION_HANGUP)) {
+		if (option_verbose >= 2) {
+			ast_verbose(VERBOSE_PREFIX_3 "Hang up due to the spied-on channel hanging up.\n");
+		}
+	} 
+
 	return res;
 }
 
